include(`domains.m4')
ca : {M}{DP:data D} msre A M DP -> conc' A -> (hyp A -> conc' B) -> conc' B -> type.
%mode ca +M +DP +RP +D +E -SP.

%abbrev ca* : msre A M DP -> conc' A -> (hyp A -> conc' B) -> conc' B -> type
 = ca _ _.

- : ca* _ (ax H) E (E H).
- : ca* _ D ax D.

% Essential cases
- : ca* (msre/and RP2 RP1)  (andr D1 D2) ([h] andl1 (E1 h) h) SP
     <- ({h1} ca* (msre/and RP2 RP1) (andr D1 D2) ([h] E1 h h1) (E1' h1))
     <- ca*  RP1 D1 E1' SP.
- : ca* (msre/and RP2 RP1) (andr D1 D2) ([h] andl2 (E2 h) h) SP
     <- ({h2} ca* (msre/and RP2 RP1) (andr D1 D2) ([h] E2 h h2) (E2' h2))
     <- ca* RP2 D2 E2' SP.
-  : ca* (msre/or FP2 FP1) (orr1 D1)
      ([h:hyp (A1 \/ A2)] orl (E1 h) (E2 h) h) F
      <- ({h1:hyp A1}
            ca* (msre/or FP2 FP1) (orr1 D1)
            ([h:hyp (A1 \/ A2)] E1 h h1) (E1' h1))
      <- ca* FP1 D1 E1' F.
-  : ca* (msre/or FP2 FP1) (orr2 D2)
      ([h:hyp (A1 \/ A2)] orl (E1 h) (E2 h) h) F
      <- ({h2:hyp A2}
            ca* (msre/or FP2 FP1) (orr2 D2)
            ([h:hyp (A1 \/ A2)] E2 h h2) (E2' h2))
      <- ca* FP2 D2 E2' F.
- : ca* (msre/imp RP2 RP1) (impr D2) ([h] impl (E1 h) (E2 h) h) SP
     <- ca* (msre/imp RP2 RP1) (impr D2) E1 E1'
     <- ({h2} ca* (msre/imp RP2 RP1) (impr D2) ([h] E2 h h2) (E2' h2))
     <- ca* RP1 E1' D2 D2'
     <- ca* RP2 D2' E2' SP.

% Left commutative cases

- : ca* FP (andl1 D1 H) E (andl1 D1' H)
     <- ({h1} ca* FP (D1 h1) E (D1' h1)).
- : ca* FP (andl2 D2 H) E (andl2 D2' H)
     <- ({h1} ca* FP (D2 h1) E (D2' h1)).
- : ca* FP (impl D1 D2 H) E (impl D1 D2' H)
     <- ({h2} ca* FP (D2 h2) E (D2' h2)).
- : ca* FP (orl D1 D2 H) E (orl D1' D2' H)
     <- ({h1} ca* FP (D1 h1) E (D1' h1))
     <- ({h2} ca* FP (D2 h2) E (D2' h2)).

% Right commutative cases

- : ca* _ D ([h] E) E.
- : ca* FP D ([h] andr (E1 h) (E2 h)) (andr E1' E2')
     <- ca* FP D E1 E1'
     <- ca* FP D E2 E2'.
- : ca* FP D ([h] andl1 (E1 h) H) (andl1 E1' H)
     <- ({h1} ca* FP D ([h] E1 h h1) (E1' h1)).
- : ca* FP D ([h] andl2 (E2 h) H) (andl2 E2' H)
     <- ({h1} ca* FP D ([h] E2 h h1) (E2' h1)).
- : ca* FP D ([h] impr (E2 h)) (impr E2')
     <- ({h1} ca* FP D ([h] E2 h h1) (E2' h1)).
- : ca* FP D ([h] impl (E1 h) (E2 h) H) (impl E1' E2' H)
     <- ca* FP D E1 E1'
     <- ({h2} ca* FP D ([h] E2 h h2) (E2' h2)).
- : ca* FP D ([h] orr1 (E1 h)) (orr1 E1')
     <- ca* FP D E1 E1'.
- : ca* FP D ([h] orr2 (E2 h)) (orr2 E2')
     <- ca* FP D E2 E2'.
- : ca* FP D ([h] orl (E1 h) (E2 h) H) (orl E1' E2' H)
     <- ({h1} ca* FP D ([h:hyp A] E1 h h1) (E1' h1))
     <- ({h2} ca* FP D ([h:hyp A] E2 h h2) (E2' h2)).

include(`admit.inc')

undivert(DIV_ADMIT)

divert(-1)
undivert